//
//  ASMetadataManager.h
//  AcidSearch
//
//  Created by Robin Hamilton-Pennell on 11/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class PZChannel;
@class PZKeyCombo;
@class PZMetaDictionary;
@class PZWebView;

@interface ASMetadataManager : NSObject {
	PZMetaDictionary *keyCombos;
	PZMetaDictionary *shortcuts;
	PZMetaDictionary *regexes;
}

+ (id)instance;

- (void)addChannel:(PZChannel *)channel;
- (void)addChannel:(PZChannel *)channel overwrite:(BOOL)overwrite;
- (void)addChildrenOfChannel:(PZChannel *)channel overwrite:(BOOL)overwrite;
- (NSArray *)channelsForSearch:(NSString *)str;
- (PZMetaDictionary *)keyCombos;
- (BOOL)performKeyCombo:(PZKeyCombo *)combo forSender:(id)sender;
- (BOOL)performKeyEquivalent:(NSEvent *)event forSender:(id)sender;
- (PZMetaDictionary *)regexes;
- (void)removeChannel:(PZChannel *)channel;
- (void)removeKeyCombo:(PZKeyCombo *)combo;
- (void)removeShortcut:(NSString *)shortcut;
- (void)removeRegex:(NSString *)regex;
- (BOOL)setKeyCombo:(PZKeyCombo *)combo forKey:(id)key action:(SEL)action target:(id)target;
- (PZMetaDictionary *)shortcuts;

@end
