//
//  PZChannelController.h
//  PZSearchChannelParser
//
//  Created by Robin Hamilton-Pennell on 2/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class PZChannel;
@class PZChannelController;

@interface PZDynamicChannelController : PZChannelController {
	NSURL *sourceURL;
	id uuid;
	BOOL dirty;
}

+ (void)refreshSearchMenu;
+ (id)searchFieldChannelController;
+ (NSMenu *)template;

- (void)addChannel:(PZChannel *)newChan edit:(BOOL)edit;
- (NSToolbar *)collectionPanelToolbar;
- (void)editChannel:(PZChannel *)chan;
- (void)fetchAllImages;
- (IBAction)fetchAllImages:(id)sender;
- (void)fetchAllImagesForChannel:(PZChannel *)channel;
- (void)fetchImageForChannel:(PZChannel *)channel;
- (id)initWithRootChannel:(PZChannel *)newRootChannel;
- (void)inspectChannel:(PZChannel *)channel;
- (IBAction)newChannel:(id)sender;
- (IBAction)newChannel:(id)channel edit:(BOOL)edit;
- (IBAction)newFolder:(id)sender;
- (IBAction)newSeparator:(id)sender;
- (NSString *)prefsKey;
- (IBAction)quickFilter:(id)sender;
- (NSArray *)quickSearchItemsWithTarget:(id)target;
- (PZChannel *)rootChannel;
- (void)save;
- (void)saveSoon;
- (void)setRootChannel:(PZChannel *)newRootChannel;
- (void)selectChannel:(PZChannel *)channel;
- (IBAction)selectChannelFromMenu:(id)sender;
- (PZChannel *)selectedChannel;
- (void)setFilterString:(NSString *)string;
- (void)setSelectedChannel:(PZChannel *)newSelectedChannel;
- (IBAction)showCollectionPanel:(id)sender;
- (IBAction)showInspector:(id)sender;
- (void)updateInspector;

@end
