//
//  PZMetaDictionary.h
//  AcidSearch
//
//  Created by Robin Hamilton-Pennell on 11/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface PZMetaDictionary : NSObject <NSCopying, NSCoding> {
	NSMutableArray	*keys;
	NSMutableArray	*objects;
	NSMutableArray	*metaDictionaries;
	id				delegate;
}

+ (id)dictionary;

- (NSArray *)allKeys;
- (NSArray *)allObjects;
- (BOOL)containsKey:(id)key;
- (BOOL)containsObject:(id)object;
- (id)delegate;
- (id)initWithKeys:(id)newKeys objects:(id)newObjects;
- (id)initWithKeys:(id)newKeys objects:(id)newObjects metaDictionaries:(id)newMetaDictionaries;
- (id)initWithObjectsAndKeys:(id)theObj, ...;
- (NSEnumerator *)keyEnumerator;
- (id)keyForObject:(id)object;
- (NSMutableDictionary *)metadataForKey:(id)key;
- (NSMutableDictionary *)metadataForObject:(id)object;
- (NSEnumerator *)objectEnumerator;
- (id)objectForKey:(id)key;
- (void)removeKey:(id)key;
- (void)removeObject:(id)object;
- (void)removeObjectAtIndex:(unsigned)index;
- (void)setDelegate:(id)newDelegate;
- (BOOL)setKey:(id)key forObject:(id)object;
- (void)setMetadata:(id)metadata forKey:(id)key;
- (BOOL)setObject:(id)object forKey:(id)key;

@end