//
//  PZProtocolObject.h
//  AcidSearch
//
//  Created by Robin Hamilton-Pennell on 9/17/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface PZProtocolObject : NSObject {
	NSMutableDictionary		*_contents;
	NSMutableArray		*_objects;
	Protocol				*_protocol;
	long					*_data;
	size_t					_dataSize;
}

+ (id)objectWithProtocol:(Protocol *)protocol;
+ (id)signatureWithObjCTypes:(const char *)type;

- (BOOL)conformsToProtocol:(Protocol *)aProtocol;
- (void)dealloc;
- (void)forwardInvocation:(NSInvocation *)invocation;
- (id)init;
- (id)initWithProtocol:(Protocol *)newProtocol;
- (BOOL)getValue:(void *)value forKey:(NSString *)key;
- (NSMethodSignature *)methodSignatureForSelector:(SEL)aSelector;
- (void)setIntValue:(int)val forKey:(NSString *)key;
- (void)setUIntValue:(unsigned int)val forKey:(NSString *)key;
- (void)setObjectValue:(id)val forKey:(NSString *)key;
- (BOOL)setValue:(void *)value forKey:(NSString *)key ofObjCType:(const char *)type;
- (size_t)sizeOfTypeForSelector:(SEL)selector;
- (const char *)typeForKey:(NSString *)key;
- (const char *)typeForSelector:(SEL)selector;
- (NSValue *)valueForKey:(NSString *)key;

@end
