// 2006 Robin Hamilton-Pennell

function Highlighter() {
	var allTerms = new Array();
	
    function SearchTerm(term) {
		this.term = term.toLowerCase();
		this.cssClass = 'PZFAYTStyle';
		this.pattern = new RegExp(this.term, 'ig');
		this.found = false;
		
		this.toString = function() {
			return 'term: '+this.term+'\ncssClass: '+this.cssClass+'\npattern: '+this.pattern;
		};
	}
	
    this.highlightTerm = function(node, term) {
		if (node.hasChildNodes()) {
			//alert(node.childNodes.length);
			for (var i = 0; i < node.childNodes.length; i++) {
				this.highlightTerm(node.childNodes[i], term);
			}
		}
		
		if (node.nodeType == 3) {
			var p = node.parentNode;
			if (p.nodeName != 'TEXTAREA' && p.nodeName != 'SCRIPT' && p.nodeName != 'STYLE') {
				var result = term.pattern.exec(node.nodeValue);
				if (result != null) {
					term.found = true;
					//foundCount++;
					var v = node.nodeValue;
					var lt = document.createTextNode(v.substr(0, result.index));
					var rt = document.createTextNode(v.substr(result.index + result[0].length));
					var span = document.createElement('SPAN');
					span.className = term.cssClass;
					span.appendChild(document.createTextNode(result[0]));
					p.insertBefore(lt, node);
					p.insertBefore(span, node);
					p.replaceChild(rt, node);
					
					/*if (rt.length)
						this.highlightTerm(rt, term);*/
				}
			}
		}
	}
	
	this.search = function(text) {
		this.highlightTerm(document.getElementsByTagName("body")[0], new SearchTerm(text));
	}
	
	this.clear = function() {
		try {
			var nodes = document.getElementsByTagName("SPAN");
			var nodes2 = new Array();
			var i;
			
			for (i = 0; i < nodes.length; i++)
				if (nodes[i].className == "PZFAYTStyle")
					nodes2.push(nodes[i]);
			
			for (i = 0; i < nodes2.length; i++) {
				var leftNode = nodes2[i].previousSibling;
				var textNode = nodes2[i].childNodes[0];
				var rightNode = nodes2[i].nextSibling;
				
				if (textNode != null) {
					var text = textNode.nodeValue;
					
					if (leftNode != null) {
						if (leftNode.nodeType == 3) {
							text = leftNode.nodeValue + text;
							leftNode.parentNode.removeChild(leftNode);
						}
					}
					
					if (rightNode != null) {
						if (rightNode.nodeType == 3) {
							text = text + rightNode.nodeValue;
							rightNode.parentNode.removeChild(rightNode);
						}
					}
					
					nodes2[i].parentNode.replaceChild(document.createTextNode(text), nodes2[i]);
				}
			}
		} catch(e) {
			// Do nothing
		}
	}
}

window.highlighter = new Highlighter;